#include	<windows.h>
#include	"CComPort.h"

CComPort::CComPort(){
	// ϐ
	m_comPort		= NULL;
	m_pFmCmd		= NULL;
	m_dFmCmdWtPt	= 0;
	m_dFmCmdRdPt	= 0;
	m_pFmCmdSend	= NULL;
	m_hThread		= NULL;
	m_dwThread		= 0;
	m_dDelay		= 0;
	m_dSpeed		= 0;
	memset(&m_cs,0x00,sizeof(m_cs));
	InitializeCriticalSection(&m_cs);
	memset(&m_csSend,0x00,sizeof(m_csSend));
	InitializeCriticalSection(&m_csSend);
}

CComPort::~CComPort(){
	DeleteCriticalSection(&m_csSend);
	DeleteCriticalSection(&m_cs);
}

BOOL CComPort::openComPort(void){
	COMMTIMEOUTS cpt;
	char		cDevName[10];
	int	cnt;
	int	bpscnt;
	const DWORD bps[] = { 625000,1500000 };
	// [vŃ|[gT
	for(cnt = 1; cnt <= 256; cnt++){
		// foCX쐬
		wsprintf(cDevName,"COM%d",cnt);
		for(bpscnt = 0; bpscnt < sizeof(bps); bpscnt++){
			// COM|[gI[v
			m_comPort = CreateFile(cDevName, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL); // VA|[gJ
			// G[̏ꍇ͏I
			if(m_comPort == NULL){
				continue;
			}
			// ^CAEgݒ
			GetCommTimeouts(m_comPort,&cpt);
			cpt.ReadTotalTimeoutMultiplier = 50;
			cpt.ReadTotalTimeoutConstant  = 100;
			SetCommTimeouts(m_comPort,&cpt);

			DCB dcb; // VA|[g̍\񂪓\
			GetCommState(m_comPort, &dcb); // ݂̐ݒlǂݍ

			dcb.BaudRate = bps[bpscnt];		// x
			dcb.ByteSize = 8;				// f[^
			dcb.Parity = NOPARITY;			// peB
			dcb.StopBits = ONESTOPBIT;		// Xgbvrbg
			dcb.fOutxCtsFlow = FALSE;		// MCTSt[
			dcb.fRtsControl = RTS_CONTROL_DISABLE;

			SetCommState(m_comPort, &dcb); // ύXݒl
			// Zbg𑗐M
			if(reset() == TRUE){
				m_dSpeed = bpscnt;
				cnt = 256;
				break;
			}
			CloseHandle(m_comPort);
			m_comPort = NULL;
		}
	}
	// |[gJȂꍇ
	if(m_comPort == NULL){
		return FALSE;
	}
	// ǂݏ|Cg͕ۑ
	m_dFmCmdWtPt	= 0;
	m_dFmCmdRdPt	= 0;

	// ݒǍ
	LoadSetting();
	// R}hobt@֘A
	m_pFmCmd = new FMCOMMAND_TICK[DEF_FM_COMMAND_LEN];
	if(m_dSpeed == 1){
		// EFCg
		m_pFmCmdSend = new BYTE[DEF_FM_COMMAND_LEN * 5];
	}else{
		// EFCgȂ
		m_pFmCmdSend = new BYTE[DEF_FM_COMMAND_LEN * 3];
	}

	// Xbh쐬
	m_bThreadRunning = TRUE;
	m_hThread = CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)&CComPort::vThreadFunc,this,0,&m_dwThread);

	// CxgIuWFNg쐬
	m_hEvent = CreateEvent(NULL,FALSE,FALSE,NULL);
	// ^C}[xݒ
	timeBeginPeriod(1);
	// ^C}[ݒ肷
	m_mTimerID = timeSetEvent(1,1,(LPTIMECALLBACK)vTimerCallback,(DWORD)this,TIME_PERIODIC);

	return TRUE;
}

BOOL CComPort::closeComPort(void){
	// ^C}[~
	timeKillEvent(m_mTimerID);
	// MXbhI
	if(m_bThreadRunning == TRUE){
		// fbhbN
		SetEvent(m_hEvent);
		m_bThreadRunning = FALSE;
		WaitForSingleObject(m_hThread,INFINITE);
		CloseHandle(m_hThread);
		m_hThread = NULL;
	}

	// R|[gN[Y
	if(m_comPort != NULL){
		CloseHandle(m_comPort); // VA|[g
		m_comPort = NULL;
	}
	// obt@J
	if(m_pFmCmd != NULL){
		delete []m_pFmCmd;
		m_pFmCmd = NULL;
	}
	if(m_pFmCmdSend != NULL){
		delete []m_pFmCmdSend;
		m_pFmCmdSend = NULL;
	}
	return TRUE;
}

// xݒ
void CComPort::setDelay(DWORD dwDelay){
	m_dDelay = dwDelay;
}

// L[ɐςݍ
BOOL	CComPort::pushReg(BYTE bReg,BYTE bData,BYTE bCmd){
	BYTE	sendCmd;
	// NeBJZbV˓
	EnterCriticalSection(&m_cs);
	EnterCriticalSection(&m_csSend);
	// R}h
	if(bCmd == 0xff){
		sendCmd = bCmd;
	}else{
		switch(bCmd & 0xf0){
			case	0x00:
			sendCmd = 0xe0 | (bCmd & 0x0f);
				break;
			case	0x10:
			sendCmd = 0xd0 | (bCmd & 0x0f);
				break;
			case	0x20:
			sendCmd = 0xb0 | (bCmd & 0x0f);
				break;
		}
	}
	m_pFmCmd[m_dFmCmdWtPt].cmd = sendCmd;
	m_pFmCmd[m_dFmCmdWtPt].addr = bReg;
	m_pFmCmd[m_dFmCmdWtPt].data = bData;
	m_pFmCmd[m_dFmCmdWtPt].tick = timeGetTime();
	m_dFmCmdWtPt = ++m_dFmCmdWtPt % DEF_FM_COMMAND_LEN;
	LeaveCriticalSection(&m_csSend);
	LeaveCriticalSection(&m_cs);
	return TRUE;
}

// L[ɐςݍ
BOOL	CComPort::pushRegTick(BYTE bReg,BYTE bData,BYTE bCmd,DWORD dTick){
	BYTE	sendCmd;
	// NeBJZbV˓
	EnterCriticalSection(&m_cs);
/*
	while(m_dFmCmdLen >= DEF_FM_COMMAND_LEN){
		OutputDebugString("buff over");
		Sleep(0);
	}
*/
	EnterCriticalSection(&m_csSend);
	// R}h
	if(bCmd == 0xff){
		sendCmd = bCmd;
	}else{
		switch(bCmd & 0xf0){
			case	0x00:
			sendCmd = 0xe0 | (bCmd & 0x0f);
				break;
			case	0x10:
			sendCmd = 0xd0 | (bCmd & 0x0f);
				break;
			case	0x20:
			sendCmd = 0xb0 | (bCmd & 0x0f);
				break;
		}
	}
	m_pFmCmd[m_dFmCmdWtPt].cmd = sendCmd;
	m_pFmCmd[m_dFmCmdWtPt].addr = bReg;
	m_pFmCmd[m_dFmCmdWtPt].data = bData;
	m_pFmCmd[m_dFmCmdWtPt].tick = dTick;
	m_dFmCmdWtPt = ++m_dFmCmdWtPt % DEF_FM_COMMAND_LEN;
	LeaveCriticalSection(&m_csSend);
	LeaveCriticalSection(&m_cs);
	return TRUE;
}

// obt@tbV
BOOL CComPort::flashBuff(void){
	// obt@̃f[^ׂđM
	DWORD numberOfPut;
	DWORD lengthOfSend;		// M镶
	DWORD dwSendLen;
	DWORD dwTick;

	// ݂̎Ԃ擾
	dwTick = timeGetTime();
	// Mobt@Ƀf[^Ȃ甲
	if(m_dFmCmdWtPt == m_dFmCmdRdPt) return TRUE;
	// M
	// Mpobt@ɃRs[
	EnterCriticalSection(&m_csSend);
	dwSendLen = 0;
	while(m_dFmCmdWtPt != m_dFmCmdRdPt){
		// MΏۂȂȂ甲
		if(m_pFmCmd[m_dFmCmdRdPt].tick + m_dDelay > dwTick){
			break;
		}
		// f[^obt@ɐςݍ
		if(m_dSpeed == 1){
			m_pFmCmdSend[dwSendLen++]	= 0x80;
			m_pFmCmdSend[dwSendLen++]	= m_pFmCmd[m_dFmCmdRdPt].cmd;
			m_pFmCmdSend[dwSendLen++]	= m_pFmCmd[m_dFmCmdRdPt].addr;
			m_pFmCmdSend[dwSendLen++]	= m_pFmCmd[m_dFmCmdRdPt].data;
			m_pFmCmdSend[dwSendLen++]	= 0x80;
		}else{
			m_pFmCmdSend[dwSendLen++]	= m_pFmCmd[m_dFmCmdRdPt].cmd;
			m_pFmCmdSend[dwSendLen++]	= m_pFmCmd[m_dFmCmdRdPt].addr;
			m_pFmCmdSend[dwSendLen++]	= m_pFmCmd[m_dFmCmdRdPt].data;
		}
		// |CgZ
		m_dFmCmdRdPt = ++m_dFmCmdRdPt % DEF_FM_COMMAND_LEN;
	}
	LeaveCriticalSection(&m_csSend);

	// MΏۂꍇ
	if(dwSendLen == 0) return TRUE;
	// M
	lengthOfSend = dwSendLen; // M镶
	WriteFile(m_comPort, m_pFmCmdSend, lengthOfSend, &numberOfPut, NULL); // |[g֑M
	// xőMłȂꍇ
	while(numberOfPut > 0){
		// 
		lengthOfSend -= numberOfPut;
		WriteFile(m_comPort, (LPVOID)((DWORD)m_pFmCmdSend + dwSendLen - lengthOfSend), lengthOfSend, &numberOfPut, NULL); // |[g֑M
	}
	return TRUE;
}

// Xbh֐
DWORD	CComPort::vThreadFunc(LPVOID pParam){
	// Xbh֐Ăяo
	return ((CComPort*)pParam)->threadFunc();
}

// Xbh֐
DWORD CComPort::threadFunc(void){
	// XbhNԐݒ

	while(m_bThreadRunning){
		// Xbh~
		WaitForSingleObject(m_hEvent,INFINITE);
		// ꊇM
		flashBuff();
	}
	return 0;
}

void CComPort::vTimerCallback(UINT uTimerID,UINT uMsg,DWORD dwUser,DWORD dw1,DWORD dw2){
	CComPort	*pCcom;
	pCcom = (CComPort*)dwUser;
	pCcom->timerCallback();
}

void CComPort::timerCallback(void){
	SetEvent(m_hEvent);
}


// ZbgR}hs
BOOL CComPort::reset(void){
	BYTE rstCmd[] = {0xff};
	BYTE result[2] = {0x00,0x00};
	DWORD numberOfPut;
	DWORD lengthOfSent = 1; // M镶
	DWORD numberOfRead;

	flashBuff();

	// ZbgR}hs
	WriteFile(m_comPort, &rstCmd, lengthOfSent, &numberOfPut, NULL); // |[g֑M

	// ACK擾
	ReadFile(m_comPort,&result,2,&numberOfRead,NULL);
	if(numberOfRead != 2){
		return FALSE;
	}
	if(result[0] != 'O' && result[1] != 'K'){
		return FALSE;
	}
	return TRUE;
}

// ݒǍ
void	CComPort::LoadSetting(){
	// ̃pX擾
	char	curDir[MAX_PATH] = {0};
	char	val[256];
	if(GetCurrentDirectory(MAX_PATH,curDir)){
		lstrcat(curDir,"\\X68Sound.ini");
		GetPrivateProfileString("SPFM","DELAY","0",val,sizeof(val),curDir);
		m_dDelay = atol(val);
	}
}

